package task.db2;

import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.util.ArrayList;

import com.google.java.contract.Ensures;
import com.google.java.contract.Requires;

public class Encryption {
	
	private Byte INT = 0;
	private Byte STRING = 1;
	
	@Requires({
		"in != null",
		"(in.getClass() == String.class) || (in.getClass() == Integer.class)",
		"(in.getClass() == String.class)? !((String) in).isEmpty() : true"
	})
	@Ensures({
		"result != null"
	})
	public ArrayList<Byte> encrypt(Object in) {
		
		ArrayList<Byte> out = new ArrayList<Byte>();
		
		if(in.getClass() == Integer.class) {
			out.add(INT);
			Integer tin = (Integer) in;
			ByteBuffer bb = ByteBuffer.allocate(Integer.BYTES);
			bb.putInt(~tin);
			for(int i = 0 ; i < bb.capacity() ; i++) {
				out.add(bb.get(i));
			}
		}
		else {
			out.add(STRING);
			String tin = (String) in;
			ByteBuffer bb = ByteBuffer.allocate(tin.length());
			bb.put(tin.getBytes());
			for(int i = 0 ; i < bb.capacity() ; i++) {
				out.add(Integer.valueOf(~bb.get(i)).byteValue());
			}
		}
		
		//System.out.println("OUTPUT:" + out.toString());
		return out;
	}
	
	@Requires({
		"in != null",
		"in.size() > 1 && (in.get(0) >>> 1) == 0",
		"(in.get(0) == INT)? in.size() == Integer.BYTES + 1 : true"
	})
	@Ensures({
		"result != null"
	})
	public Object decrypt(ArrayList<Byte> in) {
		
		Object out;
		
		if(in.get(0) == INT) {
			ByteBuffer bb = ByteBuffer.allocate(Integer.BYTES);
			for(int i = 0 ; i < Integer.BYTES ; i++) {
				bb.put(i,Integer.valueOf(in.get(i+1)).byteValue());
			}
			out = Integer.valueOf(bb.getInt());
		}
		else {
			ByteBuffer bb = ByteBuffer.allocate(in.size()-1);
			for(int i = 0 ; i < in.size()-1 ; i++) {
				bb.put(i,Integer.valueOf(~in.get(i+1)).byteValue());
			}
			out = new String(bb.array());
		}
		
		//System.out.println("OUTPUT:" + out.toString());
		return out;
		
	}
	
	protected boolean isResultOK(Object data, ArrayList<Byte> code) {
		boolean br = false;
		
		if(data.getClass() == Integer.class) {
			Integer td = (Integer) data;
			if(br = (code.get(0) == INT && code.size() == Integer.BYTES + 1))
			{
				ByteBuffer bb = ByteBuffer.allocate(Integer.BYTES);
				bb.putInt(td);
				for(int i = 0; (i < Integer.BYTES && br) ; i++) {
					if(br = (Integer.valueOf(bb.get(i) ^ 0xFF).byteValue() == code.get(i+1)))
						continue;
				}
			}
		}
		else {
			String td = (String) data;
			if(br = (code.get(0) == STRING && code.size() == td.getBytes().length + 1))
			{
				ByteBuffer bb = ByteBuffer.allocate(td.getBytes().length);
				bb.put(td.getBytes());
				for(int i = 0; (i < td.getBytes().length && br) ; i++) {
					if(br = (Integer.valueOf(bb.get(i) ^ 0xFF).byteValue() == code.get(i+1)))
						continue;
				}
			}
			
		}
		
		return br;
		
	}

}
