package task.db2;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.google.java.contract.Ensures;

public class PlainDB extends Database {
	
	
	public PlainDB() {
		data = new HashMap<Integer,Integer>();
		users = new HashMap<String,String>();
		loggedin = new ArrayList<String>();
	}

	@Override
	public void register(String name, String passwd) {
		// TODO Auto-generated method stub
		users.put(name, passwd);
	}

	@Override
	public void login(String name, String passwd) {
		// TODO Auto-generated method stub
		loggedin.add(name);
		ntload++;
	}

	@Override
	public void logout(String name) {
		// TODO Auto-generated method stub
		loggedin.remove(name);
		ntload--;
	}

	@Override
	@Ensures("result == data.get(old(key))")
	public Integer readData(String name, Integer key) {
		// TODO Auto-generated method stub
		return data.get(key);
	}
	
	@Override
	@Ensures("data.get(old(key)) == old(value)")
	public void addData(String name, Integer key, Integer value) {
		// TODO Auto-generated method stub
		data.put(key, value);
	}
	
	@Override
	protected boolean isRegistered(String name) {
		// TODO Auto-generated method stub
		return users.containsKey(name);
	}

	@Override
	protected boolean isLoggedin(String name) {
		// TODO Auto-generated method stub
		return loggedin.contains(name);
	}
	
	@Override
	protected boolean isPasswordCorrect(String name, String passwd) {
		// TODO Auto-generated method stub
		return users.get(name).equals(passwd);
	}

	@Override
	protected boolean isDataAvailable(Integer key) {
		// TODO Auto-generated method stub
		return data.containsKey(key);
	}
	
	private Map<Integer, Integer> data;
	private Map<String, String> users;
	private List<String> loggedin;
	@Override
	protected boolean isValidName(String name) {
		// TODO Auto-generated method stub
		return name != null;
	}

	@Override
	protected boolean isValidPasswd(String passwd) {
		// TODO Auto-generated method stub
		return passwd != null;
	}

}
